// Compiled by ClojureScript 1.9.229 {}
goog.provide('swingometer.swingometer');
goog.require('cljs.core');
goog.require('clojure.string');
goog.require('re_com.core');
goog.require('re_com.box');
goog.require('re_com.util');
goog.require('re_com.validate');
goog.require('reagent.core');
swingometer.swingometer.swingometer_args_desc = new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"model","model",331153215),new cljs.core.Keyword(null,"required","required",1807647006),true,new cljs.core.Keyword(null,"type","type",1174270348),"map | atom",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.map_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"A map mapping keys to maps of the following structure: {:id :snp :name \"Scottish National Party\" :colour \"yellow\" :votes 1234}"], null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"width","width",-384071477),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"integer",new cljs.core.Keyword(null,"default","default",-1987822328),"300",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.integer_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"a CSS width"], null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"height","height",1025178622),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"integer",new cljs.core.Keyword(null,"default","default",-1987822328),"200",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.integer_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"a CSS height"], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"class","class",-2030961996),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"string",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.string_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"CSS class names, space separated, for the top-level SVG element"], null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"frame-class","frame-class",-1416443328),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"string",new cljs.core.Keyword(null,"default","default",-1987822328),"snm-frame",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.string_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"CSS class names, space separated, for the frame"], null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"hub-class","hub-class",1546469457),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"string",new cljs.core.Keyword(null,"default","default",-1987822328),"snm-hub",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.string_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"CSS class names, space separated, for the hub"], null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"scale-class","scale-class",787441037),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"string",new cljs.core.Keyword(null,"default","default",-1987822328),"snm-scale",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.string_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"CSS class names, space separated, for the scale"], null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"id","id",-1388402092),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"string",new cljs.core.Keyword(null,"default","default",-1987822328),"meter",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.string_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"Element id for this instance of the meter"], null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"gradations","gradations",1411381107),new cljs.core.Keyword(null,"reduired","reduired",78055068),false,new cljs.core.Keyword(null,"type","type",1174270348),"integer",new cljs.core.Keyword(null,"default","default",-1987822328),(5),new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.integer_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"Number of gradations to show on the scale, not counting the point."], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"style","style",-496642736),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"CSS style map",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),re_com.validate.css_style_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"CSS styles to add or override"], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"attr","attr",-604132353),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"HTML attr map",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),re_com.validate.html_attr_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 9, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),"HTML attributes, like ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":on-mouse-move"], null),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"br","br",934104792)], null),"No ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":class"], null)," or ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":style"], null),"allowed"], null)], null)], null);
swingometer.swingometer.log = console.log;
/**
 * Return the absolute value of the (numeric) argument.
 */
swingometer.swingometer.abs = (function swingometer$swingometer$abs(n){
var x__6740__auto__ = n;
var y__6741__auto__ = (- n);
return ((x__6740__auto__ > y__6741__auto__) ? x__6740__auto__ : y__6741__auto__);
});
swingometer.swingometer.full_scale_deflection = (140);
/**
 * Return the linear deflection of a needle given this `value` on the
 *   range `min-value`...`total-votes`.
 */
swingometer.swingometer.deflection = (function swingometer$swingometer$deflection(value,min_value,max_value){
var range = (max_value - min_value);
var zero_offset = (((0) - min_value) / range);
var limited = (function (){var x__6747__auto__ = (function (){var x__6740__auto__ = (zero_offset + (value / range));
var y__6741__auto__ = (0);
return ((x__6740__auto__ > y__6741__auto__) ? x__6740__auto__ : y__6741__auto__);
})();
var y__6748__auto__ = (1);
return ((x__6747__auto__ < y__6748__auto__) ? x__6747__auto__ : y__6748__auto__);
})();
return ((limited - 0.5) * swingometer.swingometer.full_scale_deflection);
});
/**
 * Return, as a map with keys :x. :y, the cartesian coordinates at the point
 * `radius` distance at `theta` (degrees) angle from a point at
 * cartesian coordinates `cx`, `cy`.
 */
swingometer.swingometer.polar_to_cartesian = (function swingometer$swingometer$polar_to_cartesian(cx,cy,radius,theta){
var in_radians = (((theta - (90)) * (Math["PI"])) / 180.0);
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"x","x",2099068185),(cx + (radius * Math.cos(in_radians))),new cljs.core.Keyword(null,"y","y",-1757859776),(cy + (radius * Math.sin(in_radians)))], null);
});
/**
 * Return as a string an SVG path definition describing an arc centred
 * at `cx`, cy` starting at `start-angle` and ending at `end-angle` (both
 * angles in degrees).
 */
swingometer.swingometer.describe_arc = (function swingometer$swingometer$describe_arc(cx,cy,radius,start_angle,end_angle){
var start = swingometer.swingometer.polar_to_cartesian.call(null,cx,cy,radius,start_angle);
var end = swingometer.swingometer.polar_to_cartesian.call(null,cx,cy,radius,end_angle);
var large_arc_QMARK_ = ((((end_angle - start_angle) <= (180)))?(0):(1));
var sweep = (((end_angle > start_angle))?(1):(0));
return clojure.string.join.call(null," ",new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, ["M",new cljs.core.Keyword(null,"x","x",2099068185).cljs$core$IFn$_invoke$arity$1(start),new cljs.core.Keyword(null,"y","y",-1757859776).cljs$core$IFn$_invoke$arity$1(start),"A",radius,radius,(0),large_arc_QMARK_,sweep,new cljs.core.Keyword(null,"x","x",2099068185).cljs$core$IFn$_invoke$arity$1(end),new cljs.core.Keyword(null,"y","y",-1757859776).cljs$core$IFn$_invoke$arity$1(end)], null));
});
/**
 * If this arg is a floating point number, format it to a reasonable width; else return it.
 */
swingometer.swingometer.as_label = (function swingometer$swingometer$as_label(arg){
if((typeof arg === 'number') && (!(cljs.core.integer_QMARK_.call(null,arg)))){
return arg.toFixed((2));
} else {
return arg;
}
});
/**
 * Return as a string an SVG path definition describing a radial stroke from a center
 *   at `cx`, cy` starting at `min-radius` and extending to `max-radius`.
 */
swingometer.swingometer.gradation = (function swingometer$swingometer$gradation(cx,cy,min_radius,max_radius,angle,label){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"g","g",1738089905),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"class","class",-2030961996),"snm-gradation",new cljs.core.Keyword(null,"transform","transform",1381301764),clojure.string.join.call(null," ",new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, ["rotate(",angle,cx,cy,")"], null))], null),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"path","path",-188191168),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"d","d",1972142424),clojure.string.join.call(null," ",new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, ["M",cx,(cy - (min_radius + ((max_radius - min_radius) * 0.333))),"L",cx,(cy - max_radius)], null))], null)], null),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"text","text",-1790561697),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"text-anchor","text-anchor",585613696),"start",new cljs.core.Keyword(null,"x","x",2099068185),cx,new cljs.core.Keyword(null,"y","y",-1757859776),(cy - min_radius)], null),swingometer.swingometer.as_label.call(null,label)], null)], null);
});
swingometer.swingometer.recursively_draw_segments = (function swingometer$swingometer$recursively_draw_segments(still_to_do,done,total_votes,cx,cy,radius){
swingometer.swingometer.log.call(null,clojure.string.join.call(null," ",new cljs.core.PersistentVector(null, 12, 5, cljs.core.PersistentVector.EMPTY_NODE, ["\nstill-to-do",still_to_do,"\ndone",done,"\ntotal-votes",total_votes,"cx",cx,"cy",cy,"radius",radius], null)));

if(cljs.core.empty_QMARK_.call(null,still_to_do)){
return null;
} else {
var votes_done = cljs.core.reduce.call(null,cljs.core._PLUS_,cljs.core.map.call(null,new cljs.core.Keyword(null,"votes","votes",-1161459422),done));
var start_angle = swingometer.swingometer.deflection.call(null,votes_done,(0),total_votes);
var party = cljs.core.first.call(null,still_to_do);
var end_angle = swingometer.swingometer.deflection.call(null,(new cljs.core.Keyword(null,"votes","votes",-1161459422).cljs$core$IFn$_invoke$arity$1(party) + votes_done),(0),total_votes);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"g","g",1738089905),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"path","path",-188191168),new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"class","class",-2030961996),"snm-scale",new cljs.core.Keyword(null,"id","id",-1388402092),[cljs.core.str(new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(party)),cljs.core.str("-segment")].join(''),new cljs.core.Keyword(null,"style","style",-496642736),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"stroke","stroke",1741823555),new cljs.core.Keyword(null,"colour","colour",2137094554).cljs$core$IFn$_invoke$arity$1(party)], null),new cljs.core.Keyword(null,"d","d",1972142424),swingometer.swingometer.describe_arc.call(null,cx,cy,radius,start_angle,end_angle)], null)], null),swingometer.swingometer.gradation.call(null,cx,cy,(radius * 0.8),(radius * 1.1),start_angle,(function (){var vote_share = ((new cljs.core.Keyword(null,"votes","votes",-1161459422).cljs$core$IFn$_invoke$arity$1(party) / total_votes) * (100));
return [cljs.core.str((((vote_share > (5)))?cljs.core.name.call(null,new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(party)):"")),cljs.core.str((((vote_share > (10)))?[cljs.core.str(" "),cljs.core.str((vote_share | (0))),cljs.core.str("%")].join(''):null))].join('');
})())], null),swingometer$swingometer$recursively_draw_segments.call(null,cljs.core.rest.call(null,still_to_do),cljs.core.cons.call(null,party,done),total_votes,cx,cy,radius));
}
});
/**
 * Render an SVG swinging needle meter
 */
swingometer.swingometer.swingometer = (function swingometer$swingometer$swingometer(var_args){
var args__7491__auto__ = [];
var len__7484__auto___14191 = arguments.length;
var i__7485__auto___14192 = (0);
while(true){
if((i__7485__auto___14192 < len__7484__auto___14191)){
args__7491__auto__.push((arguments[i__7485__auto___14192]));

var G__14193 = (i__7485__auto___14192 + (1));
i__7485__auto___14192 = G__14193;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((0) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((0)),(0),null)):null);
return swingometer.swingometer.swingometer.cljs$core$IFn$_invoke$arity$variadic(argseq__7492__auto__);
});

swingometer.swingometer.swingometer.cljs$core$IFn$_invoke$arity$variadic = (function (p__14188){
var map__14189 = p__14188;
var map__14189__$1 = ((((!((map__14189 == null)))?((((map__14189.cljs$lang$protocol_mask$partition0$ & (64))) || (map__14189.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__14189):map__14189);
var args = map__14189__$1;
var model = cljs.core.get.call(null,map__14189__$1,new cljs.core.Keyword(null,"model","model",331153215));
var width = cljs.core.get.call(null,map__14189__$1,new cljs.core.Keyword(null,"width","width",-384071477),(300));
var height = cljs.core.get.call(null,map__14189__$1,new cljs.core.Keyword(null,"height","height",1025178622),(200));
var class$ = cljs.core.get.call(null,map__14189__$1,new cljs.core.Keyword(null,"class","class",-2030961996));
var scale_class = cljs.core.get.call(null,map__14189__$1,new cljs.core.Keyword(null,"scale-class","scale-class",787441037),"snm-scale");
var frame_class = cljs.core.get.call(null,map__14189__$1,new cljs.core.Keyword(null,"frame-class","frame-class",-1416443328),"snm-frame");
var id = cljs.core.get.call(null,map__14189__$1,new cljs.core.Keyword(null,"id","id",-1388402092),"meter");
var style = cljs.core.get.call(null,map__14189__$1,new cljs.core.Keyword(null,"style","style",-496642736));
var attr = cljs.core.get.call(null,map__14189__$1,new cljs.core.Keyword(null,"attr","attr",-604132353));
if(cljs.core.truth_(((!(goog.DEBUG))?true:re_com.validate.validate_args.call(null,re_com.validate.extract_arg_data.call(null,swingometer.swingometer.swingometer_args_desc),args,"swingometer")))){
} else {
throw (new Error("Assert failed: (validate-args-macro swingometer-args-desc args \"swingometer\")"));
}

var model__$1 = re_com.util.deref_or_value.call(null,model);
var mid_point_deflection = (swingometer.swingometer.full_scale_deflection / (2));
var cx = (width / (2));
var cy = (height * 0.9);
var needle_length = (height * 0.75);
var scale_radius = (height * 0.7);
var gradation_inner = (height * 0.55);
var gradations = (5);
var total_votes = cljs.core.reduce.call(null,cljs.core._PLUS_,cljs.core.map.call(null,((function (model__$1,mid_point_deflection,cx,cy,needle_length,scale_radius,gradation_inner,gradations,map__14189,map__14189__$1,args,model,width,height,class$,scale_class,frame_class,id,style,attr){
return (function (p1__14186_SHARP_){
return new cljs.core.Keyword(null,"votes","votes",-1161459422).cljs$core$IFn$_invoke$arity$1(p1__14186_SHARP_);
});})(model__$1,mid_point_deflection,cx,cy,needle_length,scale_radius,gradation_inner,gradations,map__14189,map__14189__$1,args,model,width,height,class$,scale_class,frame_class,id,style,attr))
,cljs.core.vals.call(null,model__$1)));
return new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.core.box,new cljs.core.Keyword(null,"align","align",1964212802),new cljs.core.Keyword(null,"start","start",-355208981),new cljs.core.Keyword(null,"child","child",623967545),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"div","div",1057191632),cljs.core.merge.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"class","class",-2030961996),[cljs.core.str("swingometer  "),cljs.core.str(class$)].join(''),new cljs.core.Keyword(null,"style","style",-496642736),cljs.core.merge.call(null,re_com.box.flex_child_style.call(null,"none"),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"width","width",-384071477),width,new cljs.core.Keyword(null,"height","height",1025178622),height], null),style)], null),attr),new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"svg","svg",856789142),cljs.core.PersistentHashMap.fromArrays([new cljs.core.Keyword(null,"y","y",-1757859776),new cljs.core.Keyword(null,"xmlSpace","xmlSpace",-52614622),new cljs.core.Keyword(null,"overflow","overflow",2058931880),new cljs.core.Keyword(null,"width","width",-384071477),new cljs.core.Keyword(null,"id","id",-1388402092),new cljs.core.Keyword(null,"class","class",-2030961996),new cljs.core.Keyword(null,"x","x",2099068185),new cljs.core.Keyword(null,"version","version",425292698),new cljs.core.Keyword(null,"viewBox","viewBox",-469489477),new cljs.core.Keyword(null,"height","height",1025178622)],["0px","preserve","visible",[cljs.core.str(width),cljs.core.str("px")].join(''),id,[cljs.core.str("snm-meter "),cljs.core.str(class$)].join(''),"0px","1.1",clojure.string.join.call(null," ",new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0),(0),width,height], null)),[cljs.core.str(height),cljs.core.str("px")].join('')]),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"text","text",-1790561697),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"text-anchor","text-anchor",585613696),"middle",new cljs.core.Keyword(null,"x","x",2099068185),(width / (2)),new cljs.core.Keyword(null,"y","y",-1757859776),(height / (2)),new cljs.core.Keyword(null,"width","width",-384071477),"100",new cljs.core.Keyword(null,"id","id",-1388402092),[cljs.core.str(id),cljs.core.str("-total-votes")].join(''),new cljs.core.Keyword(null,"class","class",-2030961996),"snm-value"], null),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"tspan","tspan",-1557853197),cljs.core.reduce.call(null,cljs.core._PLUS_,cljs.core.map.call(null,new cljs.core.Keyword(null,"votes","votes",-1161459422),cljs.core.vals.call(null,model__$1)))], null)], null),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"path","path",-188191168),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"class","class",-2030961996),scale_class,new cljs.core.Keyword(null,"id","id",-1388402092),[cljs.core.str(id),cljs.core.str("-scale")].join(''),new cljs.core.Keyword(null,"d","d",1972142424),swingometer.swingometer.describe_arc.call(null,cx,cy,scale_radius,((0) - mid_point_deflection),mid_point_deflection)], null)], null),cljs.core.apply.call(null,cljs.core.vector,cljs.core.cons.call(null,new cljs.core.Keyword(null,"g","g",1738089905),swingometer.swingometer.recursively_draw_segments.call(null,cljs.core.map.call(null,model__$1,cljs.core.sort.call(null,cljs.core.keys.call(null,model__$1))),null,total_votes,cx,cy,scale_radius))),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"rect","rect",-108902628),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"class","class",-2030961996),frame_class,new cljs.core.Keyword(null,"id","id",-1388402092),[cljs.core.str(id),cljs.core.str("-frame")].join(''),new cljs.core.Keyword(null,"x","x",2099068185),(width * 0.05),new cljs.core.Keyword(null,"y","y",-1757859776),(height * .05),new cljs.core.Keyword(null,"height","height",1025178622),cy,new cljs.core.Keyword(null,"width","width",-384071477),(width * 0.9)], null)], null)], null)], null)], null);
});

swingometer.swingometer.swingometer.cljs$lang$maxFixedArity = (0);

swingometer.swingometer.swingometer.cljs$lang$applyTo = (function (seq14187){
return swingometer.swingometer.swingometer.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq14187));
});


//# sourceMappingURL=swingometer.js.map?rel=1499873949079