// Compiled by ClojureScript 1.9.229 {}
goog.provide('devtools.format');
goog.require('cljs.core');

/**
 * @interface
 */
devtools.format.IDevtoolsFormat = function(){};

devtools.format._header = (function devtools$format$_header(value){
if((!((value == null))) && (!((value.devtools$format$IDevtoolsFormat$_header$arity$1 == null)))){
return value.devtools$format$IDevtoolsFormat$_header$arity$1(value);
} else {
var x__7072__auto__ = (((value == null))?null:value);
var m__7073__auto__ = (devtools.format._header[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,value);
} else {
var m__7073__auto____$1 = (devtools.format._header["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,value);
} else {
throw cljs.core.missing_protocol.call(null,"IDevtoolsFormat.-header",value);
}
}
}
});

devtools.format._has_body = (function devtools$format$_has_body(value){
if((!((value == null))) && (!((value.devtools$format$IDevtoolsFormat$_has_body$arity$1 == null)))){
return value.devtools$format$IDevtoolsFormat$_has_body$arity$1(value);
} else {
var x__7072__auto__ = (((value == null))?null:value);
var m__7073__auto__ = (devtools.format._has_body[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,value);
} else {
var m__7073__auto____$1 = (devtools.format._has_body["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,value);
} else {
throw cljs.core.missing_protocol.call(null,"IDevtoolsFormat.-has-body",value);
}
}
}
});

devtools.format._body = (function devtools$format$_body(value){
if((!((value == null))) && (!((value.devtools$format$IDevtoolsFormat$_body$arity$1 == null)))){
return value.devtools$format$IDevtoolsFormat$_body$arity$1(value);
} else {
var x__7072__auto__ = (((value == null))?null:value);
var m__7073__auto__ = (devtools.format._body[goog.typeOf(x__7072__auto__)]);
if(!((m__7073__auto__ == null))){
return m__7073__auto__.call(null,value);
} else {
var m__7073__auto____$1 = (devtools.format._body["_"]);
if(!((m__7073__auto____$1 == null))){
return m__7073__auto____$1.call(null,value);
} else {
throw cljs.core.missing_protocol.call(null,"IDevtoolsFormat.-body",value);
}
}
}
});

devtools.format.setup_BANG_ = (function devtools$format$setup_BANG_(){
if(cljs.core.truth_(devtools.format._STAR_setup_done_STAR_)){
return null;
} else {
devtools.format._STAR_setup_done_STAR_ = true;

devtools.format.make_template_fn = (function (){var temp__4657__auto__ = goog.object.get(window,"devtools");
if(cljs.core.truth_(temp__4657__auto__)){
var o__15474__auto__ = temp__4657__auto__;
var temp__4657__auto____$1 = goog.object.get(o__15474__auto__,"formatters");
if(cljs.core.truth_(temp__4657__auto____$1)){
var o__15474__auto____$1 = temp__4657__auto____$1;
var temp__4657__auto____$2 = goog.object.get(o__15474__auto____$1,"templating");
if(cljs.core.truth_(temp__4657__auto____$2)){
var o__15473__auto__ = temp__4657__auto____$2;
return goog.object.get(o__15473__auto__,"make_template");
} else {
return null;
}
} else {
return null;
}
} else {
return null;
}
})();

devtools.format.make_group_fn = (function (){var temp__4657__auto__ = goog.object.get(window,"devtools");
if(cljs.core.truth_(temp__4657__auto__)){
var o__15474__auto__ = temp__4657__auto__;
var temp__4657__auto____$1 = goog.object.get(o__15474__auto__,"formatters");
if(cljs.core.truth_(temp__4657__auto____$1)){
var o__15474__auto____$1 = temp__4657__auto____$1;
var temp__4657__auto____$2 = goog.object.get(o__15474__auto____$1,"templating");
if(cljs.core.truth_(temp__4657__auto____$2)){
var o__15473__auto__ = temp__4657__auto____$2;
return goog.object.get(o__15473__auto__,"make_group");
} else {
return null;
}
} else {
return null;
}
} else {
return null;
}
})();

devtools.format.make_reference_fn = (function (){var temp__4657__auto__ = goog.object.get(window,"devtools");
if(cljs.core.truth_(temp__4657__auto__)){
var o__15474__auto__ = temp__4657__auto__;
var temp__4657__auto____$1 = goog.object.get(o__15474__auto__,"formatters");
if(cljs.core.truth_(temp__4657__auto____$1)){
var o__15474__auto____$1 = temp__4657__auto____$1;
var temp__4657__auto____$2 = goog.object.get(o__15474__auto____$1,"templating");
if(cljs.core.truth_(temp__4657__auto____$2)){
var o__15473__auto__ = temp__4657__auto____$2;
return goog.object.get(o__15473__auto__,"make_reference");
} else {
return null;
}
} else {
return null;
}
} else {
return null;
}
})();

devtools.format.make_surrogate_fn = (function (){var temp__4657__auto__ = goog.object.get(window,"devtools");
if(cljs.core.truth_(temp__4657__auto__)){
var o__15474__auto__ = temp__4657__auto__;
var temp__4657__auto____$1 = goog.object.get(o__15474__auto__,"formatters");
if(cljs.core.truth_(temp__4657__auto____$1)){
var o__15474__auto____$1 = temp__4657__auto____$1;
var temp__4657__auto____$2 = goog.object.get(o__15474__auto____$1,"templating");
if(cljs.core.truth_(temp__4657__auto____$2)){
var o__15473__auto__ = temp__4657__auto____$2;
return goog.object.get(o__15473__auto__,"make_surrogate");
} else {
return null;
}
} else {
return null;
}
} else {
return null;
}
})();

devtools.format.render_markup_fn = (function (){var temp__4657__auto__ = goog.object.get(window,"devtools");
if(cljs.core.truth_(temp__4657__auto__)){
var o__15474__auto__ = temp__4657__auto__;
var temp__4657__auto____$1 = goog.object.get(o__15474__auto__,"formatters");
if(cljs.core.truth_(temp__4657__auto____$1)){
var o__15474__auto____$1 = temp__4657__auto____$1;
var temp__4657__auto____$2 = goog.object.get(o__15474__auto____$1,"templating");
if(cljs.core.truth_(temp__4657__auto____$2)){
var o__15473__auto__ = temp__4657__auto____$2;
return goog.object.get(o__15473__auto__,"render_markup");
} else {
return null;
}
} else {
return null;
}
} else {
return null;
}
})();

devtools.format._LT_header_GT__fn = (function (){var temp__4657__auto__ = goog.object.get(window,"devtools");
if(cljs.core.truth_(temp__4657__auto__)){
var o__15474__auto__ = temp__4657__auto__;
var temp__4657__auto____$1 = goog.object.get(o__15474__auto__,"formatters");
if(cljs.core.truth_(temp__4657__auto____$1)){
var o__15474__auto____$1 = temp__4657__auto____$1;
var temp__4657__auto____$2 = goog.object.get(o__15474__auto____$1,"markup");
if(cljs.core.truth_(temp__4657__auto____$2)){
var o__15473__auto__ = temp__4657__auto____$2;
return goog.object.get(o__15473__auto__,"_LT_header_GT_");
} else {
return null;
}
} else {
return null;
}
} else {
return null;
}
})();

devtools.format._LT_standard_body_GT__fn = (function (){var temp__4657__auto__ = goog.object.get(window,"devtools");
if(cljs.core.truth_(temp__4657__auto__)){
var o__15474__auto__ = temp__4657__auto__;
var temp__4657__auto____$1 = goog.object.get(o__15474__auto__,"formatters");
if(cljs.core.truth_(temp__4657__auto____$1)){
var o__15474__auto____$1 = temp__4657__auto____$1;
var temp__4657__auto____$2 = goog.object.get(o__15474__auto____$1,"markup");
if(cljs.core.truth_(temp__4657__auto____$2)){
var o__15473__auto__ = temp__4657__auto____$2;
return goog.object.get(o__15473__auto__,"_LT_standard_body_GT_");
} else {
return null;
}
} else {
return null;
}
} else {
return null;
}
})();

if(cljs.core.truth_(devtools.format.make_template_fn)){
} else {
throw (new Error("Assert failed: make-template-fn"));
}

if(cljs.core.truth_(devtools.format.make_group_fn)){
} else {
throw (new Error("Assert failed: make-group-fn"));
}

if(cljs.core.truth_(devtools.format.make_reference_fn)){
} else {
throw (new Error("Assert failed: make-reference-fn"));
}

if(cljs.core.truth_(devtools.format.make_surrogate_fn)){
} else {
throw (new Error("Assert failed: make-surrogate-fn"));
}

if(cljs.core.truth_(devtools.format.render_markup_fn)){
} else {
throw (new Error("Assert failed: render-markup-fn"));
}

if(cljs.core.truth_(devtools.format._LT_header_GT__fn)){
} else {
throw (new Error("Assert failed: <header>-fn"));
}

if(cljs.core.truth_(devtools.format._LT_standard_body_GT__fn)){
return null;
} else {
throw (new Error("Assert failed: <standard-body>-fn"));
}
}
});
devtools.format.render_markup = (function devtools$format$render_markup(var_args){
var args__7491__auto__ = [];
var len__7484__auto___15495 = arguments.length;
var i__7485__auto___15496 = (0);
while(true){
if((i__7485__auto___15496 < len__7484__auto___15495)){
args__7491__auto__.push((arguments[i__7485__auto___15496]));

var G__15497 = (i__7485__auto___15496 + (1));
i__7485__auto___15496 = G__15497;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((0) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((0)),(0),null)):null);
return devtools.format.render_markup.cljs$core$IFn$_invoke$arity$variadic(argseq__7492__auto__);
});

devtools.format.render_markup.cljs$core$IFn$_invoke$arity$variadic = (function (args){
devtools.format.setup_BANG_.call(null);

return cljs.core.apply.call(null,devtools.format.render_markup_fn,args);
});

devtools.format.render_markup.cljs$lang$maxFixedArity = (0);

devtools.format.render_markup.cljs$lang$applyTo = (function (seq15494){
return devtools.format.render_markup.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq15494));
});

devtools.format.make_template = (function devtools$format$make_template(var_args){
var args__7491__auto__ = [];
var len__7484__auto___15499 = arguments.length;
var i__7485__auto___15500 = (0);
while(true){
if((i__7485__auto___15500 < len__7484__auto___15499)){
args__7491__auto__.push((arguments[i__7485__auto___15500]));

var G__15501 = (i__7485__auto___15500 + (1));
i__7485__auto___15500 = G__15501;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((0) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((0)),(0),null)):null);
return devtools.format.make_template.cljs$core$IFn$_invoke$arity$variadic(argseq__7492__auto__);
});

devtools.format.make_template.cljs$core$IFn$_invoke$arity$variadic = (function (args){
devtools.format.setup_BANG_.call(null);

return cljs.core.apply.call(null,devtools.format.make_template_fn,args);
});

devtools.format.make_template.cljs$lang$maxFixedArity = (0);

devtools.format.make_template.cljs$lang$applyTo = (function (seq15498){
return devtools.format.make_template.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq15498));
});

devtools.format.make_group = (function devtools$format$make_group(var_args){
var args__7491__auto__ = [];
var len__7484__auto___15503 = arguments.length;
var i__7485__auto___15504 = (0);
while(true){
if((i__7485__auto___15504 < len__7484__auto___15503)){
args__7491__auto__.push((arguments[i__7485__auto___15504]));

var G__15505 = (i__7485__auto___15504 + (1));
i__7485__auto___15504 = G__15505;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((0) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((0)),(0),null)):null);
return devtools.format.make_group.cljs$core$IFn$_invoke$arity$variadic(argseq__7492__auto__);
});

devtools.format.make_group.cljs$core$IFn$_invoke$arity$variadic = (function (args){
devtools.format.setup_BANG_.call(null);

return cljs.core.apply.call(null,devtools.format.make_group_fn,args);
});

devtools.format.make_group.cljs$lang$maxFixedArity = (0);

devtools.format.make_group.cljs$lang$applyTo = (function (seq15502){
return devtools.format.make_group.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq15502));
});

devtools.format.make_surrogate = (function devtools$format$make_surrogate(var_args){
var args__7491__auto__ = [];
var len__7484__auto___15507 = arguments.length;
var i__7485__auto___15508 = (0);
while(true){
if((i__7485__auto___15508 < len__7484__auto___15507)){
args__7491__auto__.push((arguments[i__7485__auto___15508]));

var G__15509 = (i__7485__auto___15508 + (1));
i__7485__auto___15508 = G__15509;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((0) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((0)),(0),null)):null);
return devtools.format.make_surrogate.cljs$core$IFn$_invoke$arity$variadic(argseq__7492__auto__);
});

devtools.format.make_surrogate.cljs$core$IFn$_invoke$arity$variadic = (function (args){
devtools.format.setup_BANG_.call(null);

return cljs.core.apply.call(null,devtools.format.make_surrogate_fn,args);
});

devtools.format.make_surrogate.cljs$lang$maxFixedArity = (0);

devtools.format.make_surrogate.cljs$lang$applyTo = (function (seq15506){
return devtools.format.make_surrogate.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq15506));
});

devtools.format.template = (function devtools$format$template(var_args){
var args__7491__auto__ = [];
var len__7484__auto___15511 = arguments.length;
var i__7485__auto___15512 = (0);
while(true){
if((i__7485__auto___15512 < len__7484__auto___15511)){
args__7491__auto__.push((arguments[i__7485__auto___15512]));

var G__15513 = (i__7485__auto___15512 + (1));
i__7485__auto___15512 = G__15513;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((0) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((0)),(0),null)):null);
return devtools.format.template.cljs$core$IFn$_invoke$arity$variadic(argseq__7492__auto__);
});

devtools.format.template.cljs$core$IFn$_invoke$arity$variadic = (function (args){
devtools.format.setup_BANG_.call(null);

return cljs.core.apply.call(null,devtools.format.make_template_fn,args);
});

devtools.format.template.cljs$lang$maxFixedArity = (0);

devtools.format.template.cljs$lang$applyTo = (function (seq15510){
return devtools.format.template.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq15510));
});

devtools.format.group = (function devtools$format$group(var_args){
var args__7491__auto__ = [];
var len__7484__auto___15515 = arguments.length;
var i__7485__auto___15516 = (0);
while(true){
if((i__7485__auto___15516 < len__7484__auto___15515)){
args__7491__auto__.push((arguments[i__7485__auto___15516]));

var G__15517 = (i__7485__auto___15516 + (1));
i__7485__auto___15516 = G__15517;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((0) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((0)),(0),null)):null);
return devtools.format.group.cljs$core$IFn$_invoke$arity$variadic(argseq__7492__auto__);
});

devtools.format.group.cljs$core$IFn$_invoke$arity$variadic = (function (args){
devtools.format.setup_BANG_.call(null);

return cljs.core.apply.call(null,devtools.format.make_group_fn,args);
});

devtools.format.group.cljs$lang$maxFixedArity = (0);

devtools.format.group.cljs$lang$applyTo = (function (seq15514){
return devtools.format.group.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq15514));
});

devtools.format.surrogate = (function devtools$format$surrogate(var_args){
var args__7491__auto__ = [];
var len__7484__auto___15519 = arguments.length;
var i__7485__auto___15520 = (0);
while(true){
if((i__7485__auto___15520 < len__7484__auto___15519)){
args__7491__auto__.push((arguments[i__7485__auto___15520]));

var G__15521 = (i__7485__auto___15520 + (1));
i__7485__auto___15520 = G__15521;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((0) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((0)),(0),null)):null);
return devtools.format.surrogate.cljs$core$IFn$_invoke$arity$variadic(argseq__7492__auto__);
});

devtools.format.surrogate.cljs$core$IFn$_invoke$arity$variadic = (function (args){
devtools.format.setup_BANG_.call(null);

return cljs.core.apply.call(null,devtools.format.make_surrogate_fn,args);
});

devtools.format.surrogate.cljs$lang$maxFixedArity = (0);

devtools.format.surrogate.cljs$lang$applyTo = (function (seq15518){
return devtools.format.surrogate.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq15518));
});

devtools.format.reference = (function devtools$format$reference(var_args){
var args__7491__auto__ = [];
var len__7484__auto___15529 = arguments.length;
var i__7485__auto___15530 = (0);
while(true){
if((i__7485__auto___15530 < len__7484__auto___15529)){
args__7491__auto__.push((arguments[i__7485__auto___15530]));

var G__15531 = (i__7485__auto___15530 + (1));
i__7485__auto___15530 = G__15531;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((1) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((1)),(0),null)):null);
return devtools.format.reference.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__7492__auto__);
});

devtools.format.reference.cljs$core$IFn$_invoke$arity$variadic = (function (object,p__15525){
var vec__15526 = p__15525;
var state_override = cljs.core.nth.call(null,vec__15526,(0),null);
devtools.format.setup_BANG_.call(null);

return cljs.core.apply.call(null,devtools.format.make_reference_fn,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [object,((function (vec__15526,state_override){
return (function (p1__15522_SHARP_){
return cljs.core.merge.call(null,p1__15522_SHARP_,state_override);
});})(vec__15526,state_override))
], null));
});

devtools.format.reference.cljs$lang$maxFixedArity = (1);

devtools.format.reference.cljs$lang$applyTo = (function (seq15523){
var G__15524 = cljs.core.first.call(null,seq15523);
var seq15523__$1 = cljs.core.next.call(null,seq15523);
return devtools.format.reference.cljs$core$IFn$_invoke$arity$variadic(G__15524,seq15523__$1);
});

devtools.format.standard_reference = (function devtools$format$standard_reference(target){
devtools.format.setup_BANG_.call(null);

return devtools.format.make_template_fn.call(null,new cljs.core.Keyword(null,"ol","ol",932524051),new cljs.core.Keyword(null,"standard-ol-style","standard-ol-style",2143825615),devtools.format.make_template_fn.call(null,new cljs.core.Keyword(null,"li","li",723558921),new cljs.core.Keyword(null,"standard-li-style","standard-li-style",413442955),devtools.format.make_reference_fn.call(null,target)));
});
devtools.format.build_header = (function devtools$format$build_header(var_args){
var args__7491__auto__ = [];
var len__7484__auto___15533 = arguments.length;
var i__7485__auto___15534 = (0);
while(true){
if((i__7485__auto___15534 < len__7484__auto___15533)){
args__7491__auto__.push((arguments[i__7485__auto___15534]));

var G__15535 = (i__7485__auto___15534 + (1));
i__7485__auto___15534 = G__15535;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((0) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((0)),(0),null)):null);
return devtools.format.build_header.cljs$core$IFn$_invoke$arity$variadic(argseq__7492__auto__);
});

devtools.format.build_header.cljs$core$IFn$_invoke$arity$variadic = (function (args){
devtools.format.setup_BANG_.call(null);

return devtools.format.render_markup.call(null,cljs.core.apply.call(null,devtools.format._LT_header_GT__fn,args));
});

devtools.format.build_header.cljs$lang$maxFixedArity = (0);

devtools.format.build_header.cljs$lang$applyTo = (function (seq15532){
return devtools.format.build_header.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq15532));
});

devtools.format.standard_body_template = (function devtools$format$standard_body_template(var_args){
var args__7491__auto__ = [];
var len__7484__auto___15538 = arguments.length;
var i__7485__auto___15539 = (0);
while(true){
if((i__7485__auto___15539 < len__7484__auto___15538)){
args__7491__auto__.push((arguments[i__7485__auto___15539]));

var G__15540 = (i__7485__auto___15539 + (1));
i__7485__auto___15539 = G__15540;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((1) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((1)),(0),null)):null);
return devtools.format.standard_body_template.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__7492__auto__);
});

devtools.format.standard_body_template.cljs$core$IFn$_invoke$arity$variadic = (function (lines,rest){
devtools.format.setup_BANG_.call(null);

var args = cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.map.call(null,(function (x){
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [x], null);
}),lines)], null),rest);
return devtools.format.render_markup.call(null,cljs.core.apply.call(null,devtools.format._LT_standard_body_GT__fn,args));
});

devtools.format.standard_body_template.cljs$lang$maxFixedArity = (1);

devtools.format.standard_body_template.cljs$lang$applyTo = (function (seq15536){
var G__15537 = cljs.core.first.call(null,seq15536);
var seq15536__$1 = cljs.core.next.call(null,seq15536);
return devtools.format.standard_body_template.cljs$core$IFn$_invoke$arity$variadic(G__15537,seq15536__$1);
});


//# sourceMappingURL=format.js.map?rel=1499873951251