// Compiled by ClojureScript 1.9.229 {}
goog.provide('devtools.formatters.templating');
goog.require('cljs.core');
goog.require('cljs.pprint');
goog.require('clojure.walk');
goog.require('devtools.util');
goog.require('devtools.protocols');
goog.require('devtools.formatters.helpers');
goog.require('devtools.formatters.state');
goog.require('clojure.string');
devtools.formatters.templating.mark_as_group_BANG_ = (function devtools$formatters$templating$mark_as_group_BANG_(value){
var x18066_18067 = value;
x18066_18067.devtools$protocols$IGroup$ = true;


return value;
});
devtools.formatters.templating.group_QMARK_ = (function devtools$formatters$templating$group_QMARK_(value){
if(!((value == null))){
if((false) || (value.devtools$protocols$IGroup$)){
return true;
} else {
if((!value.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_.call(null,devtools.protocols.IGroup,value);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_.call(null,devtools.protocols.IGroup,value);
}
});
devtools.formatters.templating.mark_as_template_BANG_ = (function devtools$formatters$templating$mark_as_template_BANG_(value){
var x18071_18072 = value;
x18071_18072.devtools$protocols$ITemplate$ = true;


return value;
});
devtools.formatters.templating.template_QMARK_ = (function devtools$formatters$templating$template_QMARK_(value){
if(!((value == null))){
if((false) || (value.devtools$protocols$ITemplate$)){
return true;
} else {
if((!value.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_.call(null,devtools.protocols.ITemplate,value);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_.call(null,devtools.protocols.ITemplate,value);
}
});
devtools.formatters.templating.mark_as_surrogate_BANG_ = (function devtools$formatters$templating$mark_as_surrogate_BANG_(value){
var x18076_18077 = value;
x18076_18077.devtools$protocols$ISurrogate$ = true;


return value;
});
devtools.formatters.templating.surrogate_QMARK_ = (function devtools$formatters$templating$surrogate_QMARK_(value){
if(!((value == null))){
if((false) || (value.devtools$protocols$ISurrogate$)){
return true;
} else {
if((!value.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_.call(null,devtools.protocols.ISurrogate,value);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_.call(null,devtools.protocols.ISurrogate,value);
}
});
devtools.formatters.templating.reference_QMARK_ = (function devtools$formatters$templating$reference_QMARK_(value){
var and__6397__auto__ = devtools.formatters.templating.group_QMARK_.call(null,value);
if(cljs.core.truth_(and__6397__auto__)){
return cljs.core._EQ_.call(null,(value[(0)]),"object");
} else {
return and__6397__auto__;
}
});
devtools.formatters.templating.make_group = (function devtools$formatters$templating$make_group(var_args){
var args__7491__auto__ = [];
var len__7484__auto___18085 = arguments.length;
var i__7485__auto___18086 = (0);
while(true){
if((i__7485__auto___18086 < len__7484__auto___18085)){
args__7491__auto__.push((arguments[i__7485__auto___18086]));

var G__18087 = (i__7485__auto___18086 + (1));
i__7485__auto___18086 = G__18087;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((0) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((0)),(0),null)):null);
return devtools.formatters.templating.make_group.cljs$core$IFn$_invoke$arity$variadic(argseq__7492__auto__);
});

devtools.formatters.templating.make_group.cljs$core$IFn$_invoke$arity$variadic = (function (items){
var group = devtools.formatters.templating.mark_as_group_BANG_.call(null,[]);
var seq__18081_18088 = cljs.core.seq.call(null,items);
var chunk__18082_18089 = null;
var count__18083_18090 = (0);
var i__18084_18091 = (0);
while(true){
if((i__18084_18091 < count__18083_18090)){
var item_18092 = cljs.core._nth.call(null,chunk__18082_18089,i__18084_18091);
if(cljs.core.some_QMARK_.call(null,item_18092)){
if(cljs.core.coll_QMARK_.call(null,item_18092)){
(group["push"]).apply(group,devtools.formatters.templating.mark_as_group_BANG_.call(null,cljs.core.into_array.call(null,item_18092)));
} else {
group.push(devtools.formatters.helpers.pref.call(null,item_18092));
}
} else {
}

var G__18093 = seq__18081_18088;
var G__18094 = chunk__18082_18089;
var G__18095 = count__18083_18090;
var G__18096 = (i__18084_18091 + (1));
seq__18081_18088 = G__18093;
chunk__18082_18089 = G__18094;
count__18083_18090 = G__18095;
i__18084_18091 = G__18096;
continue;
} else {
var temp__4657__auto___18097 = cljs.core.seq.call(null,seq__18081_18088);
if(temp__4657__auto___18097){
var seq__18081_18098__$1 = temp__4657__auto___18097;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__18081_18098__$1)){
var c__7220__auto___18099 = cljs.core.chunk_first.call(null,seq__18081_18098__$1);
var G__18100 = cljs.core.chunk_rest.call(null,seq__18081_18098__$1);
var G__18101 = c__7220__auto___18099;
var G__18102 = cljs.core.count.call(null,c__7220__auto___18099);
var G__18103 = (0);
seq__18081_18088 = G__18100;
chunk__18082_18089 = G__18101;
count__18083_18090 = G__18102;
i__18084_18091 = G__18103;
continue;
} else {
var item_18104 = cljs.core.first.call(null,seq__18081_18098__$1);
if(cljs.core.some_QMARK_.call(null,item_18104)){
if(cljs.core.coll_QMARK_.call(null,item_18104)){
(group["push"]).apply(group,devtools.formatters.templating.mark_as_group_BANG_.call(null,cljs.core.into_array.call(null,item_18104)));
} else {
group.push(devtools.formatters.helpers.pref.call(null,item_18104));
}
} else {
}

var G__18105 = cljs.core.next.call(null,seq__18081_18098__$1);
var G__18106 = null;
var G__18107 = (0);
var G__18108 = (0);
seq__18081_18088 = G__18105;
chunk__18082_18089 = G__18106;
count__18083_18090 = G__18107;
i__18084_18091 = G__18108;
continue;
}
} else {
}
}
break;
}

return group;
});

devtools.formatters.templating.make_group.cljs$lang$maxFixedArity = (0);

devtools.formatters.templating.make_group.cljs$lang$applyTo = (function (seq18080){
return devtools.formatters.templating.make_group.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq18080));
});

devtools.formatters.templating.make_template = (function devtools$formatters$templating$make_template(var_args){
var args__7491__auto__ = [];
var len__7484__auto___18116 = arguments.length;
var i__7485__auto___18117 = (0);
while(true){
if((i__7485__auto___18117 < len__7484__auto___18116)){
args__7491__auto__.push((arguments[i__7485__auto___18117]));

var G__18118 = (i__7485__auto___18117 + (1));
i__7485__auto___18117 = G__18118;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((2) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((2)),(0),null)):null);
return devtools.formatters.templating.make_template.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__7492__auto__);
});

devtools.formatters.templating.make_template.cljs$core$IFn$_invoke$arity$variadic = (function (tag,style,children){
var tag__$1 = devtools.formatters.helpers.pref.call(null,tag);
var style__$1 = devtools.formatters.helpers.pref.call(null,style);
var template = devtools.formatters.templating.mark_as_template_BANG_.call(null,[tag__$1,((cljs.core.empty_QMARK_.call(null,style__$1))?({}):({"style": style__$1}))]);
var seq__18112_18119 = cljs.core.seq.call(null,children);
var chunk__18113_18120 = null;
var count__18114_18121 = (0);
var i__18115_18122 = (0);
while(true){
if((i__18115_18122 < count__18114_18121)){
var child_18123 = cljs.core._nth.call(null,chunk__18113_18120,i__18115_18122);
if(cljs.core.some_QMARK_.call(null,child_18123)){
if(cljs.core.coll_QMARK_.call(null,child_18123)){
(template["push"]).apply(template,devtools.formatters.templating.mark_as_template_BANG_.call(null,cljs.core.into_array.call(null,cljs.core.keep.call(null,devtools.formatters.helpers.pref,child_18123))));
} else {
var temp__4655__auto___18124 = devtools.formatters.helpers.pref.call(null,child_18123);
if(cljs.core.truth_(temp__4655__auto___18124)){
var child_value_18125 = temp__4655__auto___18124;
template.push(child_value_18125);
} else {
}
}
} else {
}

var G__18126 = seq__18112_18119;
var G__18127 = chunk__18113_18120;
var G__18128 = count__18114_18121;
var G__18129 = (i__18115_18122 + (1));
seq__18112_18119 = G__18126;
chunk__18113_18120 = G__18127;
count__18114_18121 = G__18128;
i__18115_18122 = G__18129;
continue;
} else {
var temp__4657__auto___18130 = cljs.core.seq.call(null,seq__18112_18119);
if(temp__4657__auto___18130){
var seq__18112_18131__$1 = temp__4657__auto___18130;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__18112_18131__$1)){
var c__7220__auto___18132 = cljs.core.chunk_first.call(null,seq__18112_18131__$1);
var G__18133 = cljs.core.chunk_rest.call(null,seq__18112_18131__$1);
var G__18134 = c__7220__auto___18132;
var G__18135 = cljs.core.count.call(null,c__7220__auto___18132);
var G__18136 = (0);
seq__18112_18119 = G__18133;
chunk__18113_18120 = G__18134;
count__18114_18121 = G__18135;
i__18115_18122 = G__18136;
continue;
} else {
var child_18137 = cljs.core.first.call(null,seq__18112_18131__$1);
if(cljs.core.some_QMARK_.call(null,child_18137)){
if(cljs.core.coll_QMARK_.call(null,child_18137)){
(template["push"]).apply(template,devtools.formatters.templating.mark_as_template_BANG_.call(null,cljs.core.into_array.call(null,cljs.core.keep.call(null,devtools.formatters.helpers.pref,child_18137))));
} else {
var temp__4655__auto___18138 = devtools.formatters.helpers.pref.call(null,child_18137);
if(cljs.core.truth_(temp__4655__auto___18138)){
var child_value_18139 = temp__4655__auto___18138;
template.push(child_value_18139);
} else {
}
}
} else {
}

var G__18140 = cljs.core.next.call(null,seq__18112_18131__$1);
var G__18141 = null;
var G__18142 = (0);
var G__18143 = (0);
seq__18112_18119 = G__18140;
chunk__18113_18120 = G__18141;
count__18114_18121 = G__18142;
i__18115_18122 = G__18143;
continue;
}
} else {
}
}
break;
}

return template;
});

devtools.formatters.templating.make_template.cljs$lang$maxFixedArity = (2);

devtools.formatters.templating.make_template.cljs$lang$applyTo = (function (seq18109){
var G__18110 = cljs.core.first.call(null,seq18109);
var seq18109__$1 = cljs.core.next.call(null,seq18109);
var G__18111 = cljs.core.first.call(null,seq18109__$1);
var seq18109__$2 = cljs.core.next.call(null,seq18109__$1);
return devtools.formatters.templating.make_template.cljs$core$IFn$_invoke$arity$variadic(G__18110,G__18111,seq18109__$2);
});

devtools.formatters.templating.concat_templates_BANG_ = (function devtools$formatters$templating$concat_templates_BANG_(var_args){
var args__7491__auto__ = [];
var len__7484__auto___18146 = arguments.length;
var i__7485__auto___18147 = (0);
while(true){
if((i__7485__auto___18147 < len__7484__auto___18146)){
args__7491__auto__.push((arguments[i__7485__auto___18147]));

var G__18148 = (i__7485__auto___18147 + (1));
i__7485__auto___18147 = G__18148;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((1) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((1)),(0),null)):null);
return devtools.formatters.templating.concat_templates_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__7492__auto__);
});

devtools.formatters.templating.concat_templates_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (template,templates){
return devtools.formatters.templating.mark_as_template_BANG_.call(null,goog.object.get(template,"concat").apply(template,cljs.core.into_array.call(null,cljs.core.map.call(null,cljs.core.into_array,cljs.core.keep.call(null,devtools.formatters.helpers.pref,templates)))));
});

devtools.formatters.templating.concat_templates_BANG_.cljs$lang$maxFixedArity = (1);

devtools.formatters.templating.concat_templates_BANG_.cljs$lang$applyTo = (function (seq18144){
var G__18145 = cljs.core.first.call(null,seq18144);
var seq18144__$1 = cljs.core.next.call(null,seq18144);
return devtools.formatters.templating.concat_templates_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__18145,seq18144__$1);
});

devtools.formatters.templating.extend_template_BANG_ = (function devtools$formatters$templating$extend_template_BANG_(var_args){
var args__7491__auto__ = [];
var len__7484__auto___18151 = arguments.length;
var i__7485__auto___18152 = (0);
while(true){
if((i__7485__auto___18152 < len__7484__auto___18151)){
args__7491__auto__.push((arguments[i__7485__auto___18152]));

var G__18153 = (i__7485__auto___18152 + (1));
i__7485__auto___18152 = G__18153;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((1) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((1)),(0),null)):null);
return devtools.formatters.templating.extend_template_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__7492__auto__);
});

devtools.formatters.templating.extend_template_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (template,args){
return devtools.formatters.templating.concat_templates_BANG_.call(null,template,args);
});

devtools.formatters.templating.extend_template_BANG_.cljs$lang$maxFixedArity = (1);

devtools.formatters.templating.extend_template_BANG_.cljs$lang$applyTo = (function (seq18149){
var G__18150 = cljs.core.first.call(null,seq18149);
var seq18149__$1 = cljs.core.next.call(null,seq18149);
return devtools.formatters.templating.extend_template_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__18150,seq18149__$1);
});

devtools.formatters.templating.make_surrogate = (function devtools$formatters$templating$make_surrogate(var_args){
var args18154 = [];
var len__7484__auto___18159 = arguments.length;
var i__7485__auto___18160 = (0);
while(true){
if((i__7485__auto___18160 < len__7484__auto___18159)){
args18154.push((arguments[i__7485__auto___18160]));

var G__18161 = (i__7485__auto___18160 + (1));
i__7485__auto___18160 = G__18161;
continue;
} else {
}
break;
}

var G__18156 = args18154.length;
switch (G__18156) {
case 1:
return devtools.formatters.templating.make_surrogate.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return devtools.formatters.templating.make_surrogate.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return devtools.formatters.templating.make_surrogate.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return devtools.formatters.templating.make_surrogate.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args18154.length)].join('')));

}
});

devtools.formatters.templating.make_surrogate.cljs$core$IFn$_invoke$arity$1 = (function (object){
return devtools.formatters.templating.make_surrogate.call(null,object,null);
});

devtools.formatters.templating.make_surrogate.cljs$core$IFn$_invoke$arity$2 = (function (object,header){
return devtools.formatters.templating.make_surrogate.call(null,object,header,null);
});

devtools.formatters.templating.make_surrogate.cljs$core$IFn$_invoke$arity$3 = (function (object,header,body){
return devtools.formatters.templating.make_surrogate.call(null,object,header,body,(0));
});

devtools.formatters.templating.make_surrogate.cljs$core$IFn$_invoke$arity$4 = (function (object,header,body,start_index){
return devtools.formatters.templating.mark_as_surrogate_BANG_.call(null,(function (){var obj18158 = {"target":object,"header":header,"body":body,"startIndex":(function (){var or__6409__auto__ = start_index;
if(cljs.core.truth_(or__6409__auto__)){
return or__6409__auto__;
} else {
return (0);
}
})()};
return obj18158;
})());
});

devtools.formatters.templating.make_surrogate.cljs$lang$maxFixedArity = 4;

devtools.formatters.templating.get_surrogate_target = (function devtools$formatters$templating$get_surrogate_target(surrogate){
if(cljs.core.truth_(devtools.formatters.templating.surrogate_QMARK_.call(null,surrogate))){
} else {
throw (new Error("Assert failed: (surrogate? surrogate)"));
}

return goog.object.get(surrogate,"target");
});
devtools.formatters.templating.get_surrogate_header = (function devtools$formatters$templating$get_surrogate_header(surrogate){
if(cljs.core.truth_(devtools.formatters.templating.surrogate_QMARK_.call(null,surrogate))){
} else {
throw (new Error("Assert failed: (surrogate? surrogate)"));
}

return goog.object.get(surrogate,"header");
});
devtools.formatters.templating.get_surrogate_body = (function devtools$formatters$templating$get_surrogate_body(surrogate){
if(cljs.core.truth_(devtools.formatters.templating.surrogate_QMARK_.call(null,surrogate))){
} else {
throw (new Error("Assert failed: (surrogate? surrogate)"));
}

return goog.object.get(surrogate,"body");
});
devtools.formatters.templating.get_surrogate_start_index = (function devtools$formatters$templating$get_surrogate_start_index(surrogate){
if(cljs.core.truth_(devtools.formatters.templating.surrogate_QMARK_.call(null,surrogate))){
} else {
throw (new Error("Assert failed: (surrogate? surrogate)"));
}

return goog.object.get(surrogate,"startIndex");
});
devtools.formatters.templating.make_reference = (function devtools$formatters$templating$make_reference(var_args){
var args__7491__auto__ = [];
var len__7484__auto___18169 = arguments.length;
var i__7485__auto___18170 = (0);
while(true){
if((i__7485__auto___18170 < len__7484__auto___18169)){
args__7491__auto__.push((arguments[i__7485__auto___18170]));

var G__18171 = (i__7485__auto___18170 + (1));
i__7485__auto___18170 = G__18171;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((1) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((1)),(0),null)):null);
return devtools.formatters.templating.make_reference.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__7492__auto__);
});

devtools.formatters.templating.make_reference.cljs$core$IFn$_invoke$arity$variadic = (function (object,p__18165){
var vec__18166 = p__18165;
var state_override_fn = cljs.core.nth.call(null,vec__18166,(0),null);
if(((state_override_fn == null)) || (cljs.core.fn_QMARK_.call(null,state_override_fn))){
} else {
throw (new Error("Assert failed: (or (nil? state-override-fn) (fn? state-override-fn))"));
}

if((object == null)){
return devtools.formatters.templating.make_template.call(null,new cljs.core.Keyword(null,"span","span",1394872991),new cljs.core.Keyword(null,"nil-style","nil-style",-1505044832),new cljs.core.Keyword(null,"nil-label","nil-label",-587789203));
} else {
var sub_state = ((cljs.core.some_QMARK_.call(null,state_override_fn))?state_override_fn.call(null,devtools.formatters.state.get_current_state.call(null)):devtools.formatters.state.get_current_state.call(null));
return devtools.formatters.templating.make_group.call(null,"object",({"object": object, "config": sub_state}));
}
});

devtools.formatters.templating.make_reference.cljs$lang$maxFixedArity = (1);

devtools.formatters.templating.make_reference.cljs$lang$applyTo = (function (seq18163){
var G__18164 = cljs.core.first.call(null,seq18163);
var seq18163__$1 = cljs.core.next.call(null,seq18163);
return devtools.formatters.templating.make_reference.cljs$core$IFn$_invoke$arity$variadic(G__18164,seq18163__$1);
});

devtools.formatters.templating._STAR_current_render_stack_STAR_ = cljs.core.PersistentVector.EMPTY;
devtools.formatters.templating._STAR_current_render_path_STAR_ = cljs.core.PersistentVector.EMPTY;
devtools.formatters.templating.pprint_str = (function devtools$formatters$templating$pprint_str(markup){
var sb__7395__auto__ = (new goog.string.StringBuffer());
var _STAR_print_newline_STAR_18175_18178 = cljs.core._STAR_print_newline_STAR_;
var _STAR_print_fn_STAR_18176_18179 = cljs.core._STAR_print_fn_STAR_;
cljs.core._STAR_print_newline_STAR_ = true;

cljs.core._STAR_print_fn_STAR_ = ((function (_STAR_print_newline_STAR_18175_18178,_STAR_print_fn_STAR_18176_18179,sb__7395__auto__){
return (function (x__7396__auto__){
return sb__7395__auto__.append(x__7396__auto__);
});})(_STAR_print_newline_STAR_18175_18178,_STAR_print_fn_STAR_18176_18179,sb__7395__auto__))
;

try{var _STAR_print_level_STAR_18177_18180 = cljs.core._STAR_print_level_STAR_;
cljs.core._STAR_print_level_STAR_ = (300);

try{cljs.pprint.pprint.call(null,markup);
}finally {cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR_18177_18180;
}}finally {cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR_18176_18179;

cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR_18175_18178;
}
return [cljs.core.str(sb__7395__auto__)].join('');
});
devtools.formatters.templating.print_preview = (function devtools$formatters$templating$print_preview(markup){
var _STAR_print_level_STAR_18182 = cljs.core._STAR_print_level_STAR_;
cljs.core._STAR_print_level_STAR_ = (1);

try{return cljs.core.pr_str.call(null,markup);
}finally {cljs.core._STAR_print_level_STAR_ = _STAR_print_level_STAR_18182;
}});
devtools.formatters.templating.add_stack_separators = (function devtools$formatters$templating$add_stack_separators(stack){
return cljs.core.interpose.call(null,"-------------",stack);
});
devtools.formatters.templating.replace_fns_with_markers = (function devtools$formatters$templating$replace_fns_with_markers(stack){
var f = (function (v){
if(cljs.core.fn_QMARK_.call(null,v)){
return "##fn##";
} else {
return v;
}
});
return clojure.walk.prewalk.call(null,f,stack);
});
devtools.formatters.templating.pprint_render_calls = (function devtools$formatters$templating$pprint_render_calls(stack){
return cljs.core.map.call(null,devtools.formatters.templating.pprint_str,stack);
});
devtools.formatters.templating.pprint_render_stack = (function devtools$formatters$templating$pprint_render_stack(stack){
return clojure.string.join.call(null,"\n",devtools.formatters.templating.add_stack_separators.call(null,devtools.formatters.templating.pprint_render_calls.call(null,devtools.formatters.templating.replace_fns_with_markers.call(null,cljs.core.reverse.call(null,stack)))));
});
devtools.formatters.templating.pprint_render_path = (function devtools$formatters$templating$pprint_render_path(path){
return devtools.formatters.templating.pprint_str.call(null,path);
});
devtools.formatters.templating.assert_markup_error = (function devtools$formatters$templating$assert_markup_error(msg){
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str([cljs.core.str(msg),cljs.core.str("\n"),cljs.core.str("Render path: "),cljs.core.str(devtools.formatters.templating.pprint_render_path.call(null,devtools.formatters.templating._STAR_current_render_path_STAR_)),cljs.core.str("\n"),cljs.core.str("Render stack:\n"),cljs.core.str(devtools.formatters.templating.pprint_render_stack.call(null,devtools.formatters.templating._STAR_current_render_stack_STAR_))].join('')),cljs.core.str("\n"),cljs.core.str("false")].join('')));

});
devtools.formatters.templating.surrogate_markup_QMARK_ = (function devtools$formatters$templating$surrogate_markup_QMARK_(markup){
return (cljs.core.sequential_QMARK_.call(null,markup)) && (cljs.core._EQ_.call(null,cljs.core.first.call(null,markup),"surrogate"));
});
devtools.formatters.templating.render_special = (function devtools$formatters$templating$render_special(name,args){
var G__18184 = name;
switch (G__18184) {
case "surrogate":
var obj = cljs.core.first.call(null,args);
var converted_args = cljs.core.map.call(null,devtools.formatters.templating.render_json_ml_STAR_,cljs.core.rest.call(null,args));
return cljs.core.apply.call(null,devtools.formatters.templating.make_surrogate,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [obj], null),converted_args));

break;
case "reference":
var obj = cljs.core.first.call(null,args);
var converted_obj = (cljs.core.truth_(devtools.formatters.templating.surrogate_markup_QMARK_.call(null,obj))?devtools.formatters.templating.render_json_ml_STAR_.call(null,obj):obj);
return cljs.core.apply.call(null,devtools.formatters.templating.make_reference,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [converted_obj], null),cljs.core.rest.call(null,args)));

break;
default:
return devtools.formatters.templating.assert_markup_error.call(null,[cljs.core.str("no matching special tag name: '"),cljs.core.str(name),cljs.core.str("'")].join(''));

}
});
devtools.formatters.templating.emptyish_QMARK_ = (function devtools$formatters$templating$emptyish_QMARK_(v){
if((cljs.core.seqable_QMARK_.call(null,v)) || (cljs.core.array_QMARK_.call(null,v)) || (typeof v === 'string')){
return cljs.core.empty_QMARK_.call(null,v);
} else {
return false;
}
});
devtools.formatters.templating.render_subtree = (function devtools$formatters$templating$render_subtree(tag,children){
var vec__18189 = tag;
var html_tag = cljs.core.nth.call(null,vec__18189,(0),null);
var style = cljs.core.nth.call(null,vec__18189,(1),null);
return cljs.core.apply.call(null,devtools.formatters.templating.make_template,html_tag,style,cljs.core.map.call(null,devtools.formatters.templating.render_json_ml_STAR_,cljs.core.remove.call(null,devtools.formatters.templating.emptyish_QMARK_,cljs.core.map.call(null,devtools.formatters.helpers.pref,children))));
});
devtools.formatters.templating.render_json_ml_STAR_ = (function devtools$formatters$templating$render_json_ml_STAR_(markup){
if(!(cljs.core.sequential_QMARK_.call(null,markup))){
return markup;
} else {
var _STAR_current_render_path_STAR_18193 = devtools.formatters.templating._STAR_current_render_path_STAR_;
devtools.formatters.templating._STAR_current_render_path_STAR_ = cljs.core.conj.call(null,devtools.formatters.templating._STAR_current_render_path_STAR_,cljs.core.first.call(null,markup));

try{var tag = devtools.formatters.helpers.pref.call(null,cljs.core.first.call(null,markup));
if(typeof tag === 'string'){
return devtools.formatters.templating.render_special.call(null,tag,cljs.core.rest.call(null,markup));
} else {
if(cljs.core.sequential_QMARK_.call(null,tag)){
return devtools.formatters.templating.render_subtree.call(null,tag,cljs.core.rest.call(null,markup));
} else {
return devtools.formatters.templating.assert_markup_error.call(null,[cljs.core.str("invalid json-ml markup at "),cljs.core.str(devtools.formatters.templating.print_preview.call(null,markup)),cljs.core.str(":")].join(''));

}
}
}finally {devtools.formatters.templating._STAR_current_render_path_STAR_ = _STAR_current_render_path_STAR_18193;
}}
});
devtools.formatters.templating.render_json_ml = (function devtools$formatters$templating$render_json_ml(markup){
var _STAR_current_render_stack_STAR_18196 = devtools.formatters.templating._STAR_current_render_stack_STAR_;
var _STAR_current_render_path_STAR_18197 = devtools.formatters.templating._STAR_current_render_path_STAR_;
devtools.formatters.templating._STAR_current_render_stack_STAR_ = cljs.core.conj.call(null,devtools.formatters.templating._STAR_current_render_stack_STAR_,markup);

devtools.formatters.templating._STAR_current_render_path_STAR_ = cljs.core.conj.call(null,devtools.formatters.templating._STAR_current_render_path_STAR_,"<render-json-ml>");

try{return devtools.formatters.templating.render_json_ml_STAR_.call(null,markup);
}finally {devtools.formatters.templating._STAR_current_render_path_STAR_ = _STAR_current_render_path_STAR_18197;

devtools.formatters.templating._STAR_current_render_stack_STAR_ = _STAR_current_render_stack_STAR_18196;
}});
devtools.formatters.templating.assert_failed_markup_rendering = (function devtools$formatters$templating$assert_failed_markup_rendering(initial_value,value){
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str([cljs.core.str("result of markup rendering must be a template,\n"),cljs.core.str("resolved to "),cljs.core.str(devtools.formatters.templating.pprint_str.call(null,value)),cljs.core.str("initial value: "),cljs.core.str(devtools.formatters.templating.pprint_str.call(null,initial_value))].join('')),cljs.core.str("\n"),cljs.core.str("false")].join('')));

});
devtools.formatters.templating.render_markup_STAR_ = (function devtools$formatters$templating$render_markup_STAR_(initial_value,value){
while(true){
if(cljs.core.fn_QMARK_.call(null,value)){
var G__18198 = initial_value;
var G__18199 = value.call(null);
initial_value = G__18198;
value = G__18199;
continue;
} else {
if((value instanceof cljs.core.Keyword)){
var G__18200 = initial_value;
var G__18201 = devtools.formatters.helpers.pref.call(null,value);
initial_value = G__18200;
value = G__18201;
continue;
} else {
if(cljs.core.sequential_QMARK_.call(null,value)){
var G__18202 = initial_value;
var G__18203 = devtools.formatters.templating.render_json_ml.call(null,value);
initial_value = G__18202;
value = G__18203;
continue;
} else {
if(cljs.core.truth_(devtools.formatters.templating.template_QMARK_.call(null,value))){
return value;
} else {
if(cljs.core.truth_(devtools.formatters.templating.surrogate_QMARK_.call(null,value))){
return value;
} else {
if(cljs.core.truth_(devtools.formatters.templating.reference_QMARK_.call(null,value))){
return value;
} else {
return devtools.formatters.templating.assert_failed_markup_rendering.call(null,initial_value,value);

}
}
}
}
}
}
break;
}
});
devtools.formatters.templating.render_markup = (function devtools$formatters$templating$render_markup(value){
return devtools.formatters.templating.render_markup_STAR_.call(null,value,value);
});

//# sourceMappingURL=templating.js.map?rel=1499873955108